import pygame
from pygame.locals import *
from const import *
#import pygame.draw


import os
from pgu import engine
import pgu.text
import sound_info

"""
data = [
    (pygame.Rect(200,81,201,157),'Comfy Castle',4397,'level8.tga',100),
    (pygame.Rect(92,152,77,150),'Truthful Tower',1232,'level5.tga',100),
    (pygame.Rect(294,260,69,95),'Loyal Lookout',982,'level6.tga',100),
    (pygame.Rect(451,165,62,161),'Observatory of Honor',1444,'level7.tga',100),
    (pygame.Rect(17,335,99,58),'Simple City',214,'level1.tga',100),
    (pygame.Rect(144,390,117,52),'Valiant Village',319,'level2.tga',100),
    (pygame.Rect(325,378,118,54),'Humble Hamlet',182,'level3.tga',100),
    (pygame.Rect(509,328,96,66),'Congenial Burg',225,'level4.tga',100),
    ]
""" 
iy = img_shift_y = 44
data = [
    (7,pygame.Rect(176, 7+iy, 213, 157),'Comfy Castle',4397,'level8.tga',70,        "Zanthor's Castle",'soundtrack3.ogg'),
    (4,pygame.Rect(100, 179+iy, 119, 94),'Truthful Tower',1232,'level5.tga',70,     "Zanthor's Obelisk",'soundtrack2.ogg'),
    (4,pygame.Rect(270, 179+iy, 119, 94),'Loyal Lookout',982,'level6.tga',70,       "Zanthor's Sausage Tree",'soundtrack2.ogg'),
    (4,pygame.Rect(389, 148+iy, 123, 125),'Observatory of Honor',1444,'level7.tga',70,"Zanthor's Toothpick",'soundtrack2.ogg'),

    (0,pygame.Rect(32, 237+iy, 144,  135),'Simple City',214,'level1.tga',80,        "Zanthor's Footstool",'soundtrack1.ogg'),
    (0,pygame.Rect(176, 273+iy, 125, 135),'Valiant Village',319,'level2.tga',80,    "Zanthor's Garden" ,'soundtrack1.ogg'),
    (0,pygame.Rect(301, 273+iy, 117, 83),'Humble Hamlet',182,'level3.tga',80,       "Zanthor's Coal Mine",'soundtrack1.ogg'),
    (0,pygame.Rect(487, 273+iy, 121, 135),'Congenial Burg',225,'level4.tga',80,     "Zanthor's Rec Room",'soundtrack1.ogg'),
    ]

"""
32, 237, 144,  135
176, 273, 125, 135
231, 273, 117, 83
487, 273, 121, 135

106, 179, 109, 94
119, 94, 270, 179
123, 125, 289, 148
213, 160, 176, 8
"""


class Menu(engine.State):
    
    def init(self):
        self.bkgr = pygame.image.load(os.path.join("data","gfx","caastles.png")).convert()
        #rev up music...
        
        self.fonts = {}
        
        for size in [48,24]:
            self.fonts[size] = pygame.font.Font(os.path.join("data","menu","vinque.ttf"),size)

        self.game.sm.Play(sound_info.birds[0])
        self.last_start = self.game.cur_time
        self.last_end = self.game.elapsed_time + self.game.sm.sounds[sound_info.birds.cur()].get_length()


        self.frames = 0
        self.level = None
        self.ximg = pygame.image.load(os.path.join("data","menu","x.png")).convert_alpha()
        pygame.mouse.set_visible(True)
        self.done = self.game.data['levels']
        
        pygame.mixer.music.stop()

    def paint(self,screen):
        screen.blit(self.bkgr,(0,img_shift_y))
        screen.blit(self.bkgr,(0,-SH+img_shift_y))
        
        fg = (0,0,0)
        fg2 = (62,166,49)
        fnt = self.fonts[48]
        

        text = "Sunflower Kingdom"
        img = fnt.render(text,1,fg2)
        x,y = (SW-img.get_width())/2,4
        #screen.blit(img,(x-1,y+1))
        pgu.text.write(screen,fnt,(x,y),(255,255,255),text,1)


#         img = fnt.render("Sunflower Kingdom",1,fg)
#         x,y = (SW-img.get_width())/2,4
#         screen.blit(img,(x,y))
        
        pos = pygame.mouse.get_pos()
        
        fnt = self.fonts[24]
        self.level = None
        
        done = self.done
        img = self.ximg
        for lock,r,title,pop,n,perc,ztitle,music in data:
            if n in done:
                screen.blit(img,(r.x+(r.w-img.get_width())/2,r.y+(r.h-img.get_height())/2))

        for lock,r,title,pop,n,perc,ztitle,music in data:
            #pygame.draw.rect(screen, (0,0,0), r, 1)
            if r.collidepoint(pos):
                t = title
                if n in done: t,pop = ztitle,0
                
                locked = False
                if len(self.game.data['levels']) < lock: locked = True
                text = "%s - %s  -  %d citizens"%(n,t,pop)
                text = "%s  -  %d citizens"%(t,pop)
                
                img = fnt.render(text,1,fg)
                #img2 = fnt.render(text,1,fg2)
                x,y = (SW-img.get_width())/2,SH-8-img.get_height()
                pgu.text.write(screen,fnt,(x,y),(255,255,255),text,1)
                
                if locked:
                    text = 'locked'
                    img = fnt.render(text,1,fg)
                    x,y = r.centerx-img.get_width()/2,r.bottom-24
                    pgu.text.write(screen,fnt,(x,y),(255,255,255),text,1)

                #screen.blit(img2,(x-1,y+1))
                #screen.blit(img,(x,y))
                if n not in done and not locked:
                    self.level = n,perc,music
                break
            
        
        pygame.display.flip()
        return
        
        
    def loop(self):
        if not self.frames % int(FPS/ 4):

            # mix the sounds in with 1. second.
            if (self.last_end - self.game.elapsed_time) < 1.:
                self.game.sm.Play(sound_info.birds.nextone())
                self.last_start = self.game.cur_time
                self.last_end = self.game.elapsed_time + self.game.sm.sounds[sound_info.birds.cur()].get_length()

        self.frames += 1


    def update(self,screen):
        return self.paint(screen)
    
        
    
    def event(self,e):
        
        if e.type is MOUSEBUTTONDOWN and self.level != None:
            import level
            return level.Level(self.game,*self.level)
        
        if e.type is KEYDOWN and e.key == K_ESCAPE:
            import states
            import title
            return states.Prompt(self.game,"quit? y/n",title.Title(self.game),self)
        
